####
## discretize.r
## feature discretization
## Janusz
####

## returns list of breaks for each peak
hist.breaks<-function(data,n.breaks=10){
  discr<-function(x){ 
    hist<-hist(x,plot=FALSE,breaks=n.breaks)
    b<-hist$breaks    
    if (b[1]==0) b<-c((b[1]-diff(b)[1]),b)
    return(b)    
  }
  break.list<-apply(data,1,discr)
      
  if(class(break.list)=="matrix") break.list<-as.list(data.frame(t(break.list)))   
  return(break.list)
}

## remove min and max - leave true breaks
cut.hist.breaks<-function(break.list)
{ cut<-function(b)
  {return(b[-c(1,length(b))])}
  new.list<-lapply(break.list,cut)
  return(new.list)  
}


## data -  observations in columns
## breaks - list of breaks for each peak
discretize<-function(data,breaks)
{ 
  data<-as.matrix(data)
  discr<-matrix(nrow=nrow(data), ncol=ncol(data))
  for(p in 1:dim(data)[1]) {
    for(n in 1:dim(data)[2]){
      val<-sum(1*(data[p,n]>breaks[[p]]))
      discr[p,n]<-val
    }
  }
  return(discr)
}

