####
## RANK AGGREGATION SCRIPT
## Janusz 
####

rank.aggr <- function(rank.list, output.dir)
{ 
  res <- rank.list
  n.res <- length(res)
  v <- vector()
  max.length <- 0
  for(i in 1:n.res){
    v.tmp <- res[[i]][,1]
    v <- c(v,v.tmp)
    max.length <- max(max.length,length(v.tmp))
  }  
  ids <- unique(v)
  n.ids <- length(ids)
  numbers <- 0:(n.ids-1)
  v.m <- cbind(ids,numbers)
  write.table(v.m[,c(2,1)],paste(output.dir,"/var.ids.txt",sep=""), row.names=FALSE)

  
  ranks <- list()
  scores <- list()
  first.els <- vector()
  last.els <- vector()
  for(i in 1:n.res){
    v.tmp <- as.matrix(res[[i]][,1])
    v.new <- merge(v.m,v.tmp,by.x=1,by.y=1,sort=FALSE)
    r.tmp <- list(r=v.new[,2])
    ranks <- c(ranks,r.tmp)
    s.tmp <- list(s=res[[i]][,2])
    scores <- c(scores,s.tmp)
    first.els <- c(first.els,v.new[1,2])
    last.els <- c(last.els,v.new[length(v.new[,2]),2])
  }
  first.els <- unique(first.els)
  last.els <- unique(last.els)
  print(first.els)
  print(last.els)


  kanibal.matrix <- matrix(0,nrow=n.ids,ncol=n.ids)
  
  for(j in 1:length(ranks)){
      v1 <- as.vector(ranks[[j]])
      v2 <- as.vector(scores[[j]])
      for (r in 1:length(v2)){
        r.el <- v1[r]+1
        r.ids <- which(v2<v2[r])
        lesser.els <- v1[r.ids] +1
        kanibal.matrix[r.el,lesser.els] <- kanibal.matrix[r.el,lesser.els] + 1        
      }
  }
  
  #local kanibalization
  kanibalize <- function(mc.kanibal){
    for(r in 2:nrow(mc.kanibal)){
     r.tmp <- mc.kanibal[r,]
     for(r2 in (r-1):1){
       r2.tmp <- mc.kanibal[r2,]
#       if (kanibal.matrix[(r2.tmp[2]+1),(r.tmp[2]+1)]<kanibal.matrix[(r.tmp[2]+1),(r2.tmp[2]+1)]){
       if (kanibal.matrix[(r.tmp[2]+1),(r2.tmp[2]+1)]>n.res/2){
         mc.kanibal[r2,] <- mc.kanibal[(r2+1),]
         mc.kanibal[(r2+1),] <- r2.tmp
       } else break
     }
    }
    return(mc.kanibal)
  }

  
  mc1<-matrix(nrow=0,ncol=3)
  print("processing mc1")
  for(el in numbers){
    nr <- nrow(mc1) 
    #print(paste("processing element:", el,"  output rows:", nr))
    ge.el <- vector()
    for(j in 1:length(ranks)){
      v1 <- as.vector(ranks[[j]])
      v2 <- as.vector(scores[[j]])
      if (el %in% v1){
        ind <- as.numeric(which(v1==el))
        ind <- as.numeric(max(which(v2==(v2[ind]))))
        ge.el <- c(ge.el,v1[1:ind])
      }
    }
    t <- as.matrix(table(ge.el))
    r <- as.numeric(rownames(t))
    pr.vec <- (t[,1]/length(ge.el))
    sum.pr <- sum(pr.vec)
    #print(paste("Suma rowna jest:", sum.pr))
    mc.tmp <- cbind(rep(el,length(r)),r,pr.vec)
    mc1 <- rbind(mc1,mc.tmp)
  }
  nr <- nrow(mc1)
  l.tmp <- length(last.els)
  e.pr <- 1/(nr)
  ee.pr <- e.pr/l.tmp
  for(el in first.els){
    n.tmp <- sum(mc1[,1]==el)
    mc1[(mc1[,1]==el),3] <- (mc1[(mc1[,1]==el),3] - (e.pr/n.tmp))
  }
  for (el.i in first.els){
    for(el.j in last.els){
      mc1<- rbind(mc1,c(el.i, el.j, ee.pr))
    }
  }
  nr <- nrow(mc1)
  ind <- sort(mc1[,1],index.return=T)$ix
  mc1 <- mc1[ind,]
  cat(paste(n.ids,"\n",nr,"\n",sep=""),file=paste(output.dir,"/mc1.txt",sep=""))
  write.table(mc1,paste(output.dir,"/mc1.txt",sep=""), row.names=FALSE, col.names=FALSE,append=TRUE)
  system(paste("cp ",paste(output.dir,"/mc1.txt",sep=""), paste(MC.INPUT.DIR,"/mc.txt",sep="")))
  system(paste(MC.PROGRAM, " >",MC.OUTPUT.DIR,"mc_order.txt",sep=""))
  mc1.order<-as.vector(as.matrix(read.table(paste(MC.OUTPUT.DIR,"mc_order.txt",sep=""))))    
  write.table(mc1.order,paste(output.dir,"/mc1_order.txt",sep=""), row.names=FALSE, col.names=FALSE)
  mc.scores <- cbind(v.m,mc1.order)
  order <- sort(mc.scores[,3], decreasing=TRUE,index.return=TRUE)$ix
  mc1.sorted <- mc.scores[order,]

  mc1.kanibal <- mc1.sorted[,1:2]
  mc1.kanibal <- kanibalize(mc1.kanibal)

  mc2<-matrix(nrow=0,ncol=3)
  print("processing mc2")
  for(el in numbers){
    nr <- nrow(mc2) 
#    print(paste("processing element:", el,"  output rows:", nr))
    ge.el <- matrix(nrow=0, ncol=2)
    n.rankings.with.el <- 0
    for(j in 1:length(ranks)){
      v1 <- as.vector(ranks[[j]])
      v2 <- as.vector(scores[[j]])
      if (el %in% v1){
        n.rankings.with.el <- n.rankings.with.el + 1
        ind <- as.numeric(which(v1==el))
        ind <- as.numeric(max(which(v2==(v2[ind]))))
        l <- length(v1[1:ind])
        pr <- (1/l)
        ge.el <- rbind(ge.el,cbind(v1[1:ind],rep(pr,l)))
      }
    }
    ge.el <- cbind(ge.el[,1],(ge.el[,2]/n.rankings.with.el))
    a <- aggregate(ge.el[,2],by=list(ge.el[,1]),FUN=sum)
    a1 <- as.numeric(as.vector(a[,1]))
    a2 <- as.numeric(as.vector(a[,2]))
    s <- sum(a2)
    #print(paste("suma rowna jest:", s))
    mc.tmp <- cbind(rep(el,length(a1)), a1, a2)    
    mc2 <- rbind(mc2,mc.tmp)
  }
  nr <- nrow(mc2)
  l.tmp <- length(last.els)
  e.pr <- 1/(nr)
  ee.pr <- e.pr/l.tmp
  for(el in first.els){
    n.tmp <- sum(mc1[,1]==el)
    mc2[(mc2[,1]==el),3] <- (mc2[(mc2[,1]==el),3] - (e.pr/n.tmp))
  }
  for (el.i in first.els){
    for(el.j in last.els){
      mc2<- rbind(mc2,c(el.i, el.j, ee.pr))
    }
  }
  nr <- nrow(mc2)
  ind <- sort(mc2[,1],index.return=T)$ix
  mc2 <- mc2[ind,]
  cat(paste(n.ids,"\n",nr,"\n",sep=""),file=paste(output.dir,"/mc2.txt",sep=""))
  write.table(mc2,paste(output.dir,"/mc2.txt",sep=""), row.names=FALSE,col.names=FALSE,append=TRUE)
  system(paste("cp ",paste(output.dir,"/mc2.txt",sep=""), paste(MC.INPUT.DIR,"/mc.txt",sep="")))
  system(paste(MC.PROGRAM, " >",MC.OUTPUT.DIR,"mc_order.txt",sep=""))
  mc2.order<-as.vector(as.matrix(read.table(paste(MC.OUTPUT.DIR,"mc_order.txt",sep=""))))    
  write.table(mc2.order,paste(output.dir,"/mc2_order.txt",sep=""), row.names=FALSE, col.names=FALSE)
  mc.scores <- cbind(mc.scores,mc2.order)
  order <- sort(mc.scores[,4], decreasing=TRUE,index.return=TRUE)$ix
  mc2.sorted <- mc.scores[order,]
  mc2.kanibal <- mc2.sorted[,1:2]
  mc2.kanibal <- kanibalize(mc2.kanibal)


  mc3<-matrix(nrow=0,ncol=3)
  print("processing mc3")
  for(el in numbers){
    nr <- nrow(mc3) 
#    print(paste("processing element:", el,"  output rows:", nr))
    ge.el <- matrix(nrow=0, ncol=2)
    n.rankings.with.el <- 0
    for(j in 1:length(ranks)){
      v1 <- as.vector(ranks[[j]])
      v2 <- as.vector(scores[[j]])
      if (el %in% v1){
        n.rankings.with.el <- n.rankings.with.el + 1
        ind <- as.numeric(which(v1==el))
        l <- length(v1[1:ind])
        pr <- rep(1,l)
        l2 <- length(v1)
        pr[ind]<-length(v1[ind:l2])
        pr <- (pr/l2)
        ge.el <- rbind(ge.el,cbind(v1[1:ind],pr))
      }
    }
    ge.el <- cbind(ge.el[,1],(ge.el[,2]/n.rankings.with.el))
    a <- aggregate(ge.el[,2],by=list(ge.el[,1]),FUN=sum)
    a1 <- as.numeric(as.vector(a[,1]))
    a2 <- as.numeric(as.vector(a[,2]))
    s <- sum(a2)
    #print(paste("suma rowna jest:", s))
    mc.tmp <- cbind(rep(el,length(a1)), a1, a2)    
    mc3 <- rbind(mc3,mc.tmp)
  }
  nr <- nrow(mc3)
  l.tmp <- length(last.els)
  e.pr <- 1/(nr)
  ee.pr <- e.pr/l.tmp
  for(el in first.els){
    n.tmp <- sum(mc1[,1]==el)
    mc3[(mc3[,1]==el),3] <- (mc3[(mc3[,1]==el),3] - (e.pr/n.tmp))
  }
  for (el.i in first.els){
    for(el.j in last.els){
      mc3<- rbind(mc3,c(el.i, el.j, ee.pr))
    }
  }
  nr <- nrow(mc3)
  ind <- sort(mc3[,1],index.return=T)$ix
  mc3 <- mc3[ind,]
  cat(paste(n.ids,"\n",nr,"\n",sep=""),file=paste(output.dir,"/mc3.txt",sep=""))
  write.table(mc3,paste(output.dir,"/mc3.txt",sep=""), row.names=FALSE, col.names=FALSE,append=TRUE)
  system(paste("cp ",paste(output.dir,"/mc3.txt",sep=""), paste(MC.INPUT.DIR,"/mc.txt",sep="")))
  system(paste(MC.PROGRAM, " >",MC.OUTPUT.DIR,"mc_order.txt",sep=""))
  mc3.order<-as.vector(as.matrix(read.table(paste(MC.OUTPUT.DIR,"mc_order.txt",sep=""))))    
  write.table(mc3.order,paste(output.dir,"/mc3_order.txt",sep=""), row.names=FALSE, col.names=FALSE)
  mc.scores <- cbind(mc.scores,mc3.order)
  order <- sort(mc.scores[,5], decreasing=TRUE,index.return=TRUE)$ix
  mc3.sorted <- mc.scores[order,]
  mc3.kanibal <- mc3.sorted[,1:2]
  mc3.kanibal <- kanibalize(mc3.kanibal)


  mc4 <- matrix(nrow=0,ncol=3)
  print("processsing mc4")
  for(el in numbers){
    nr <- nrow(mc3) 
#    print(paste("processing element:", el,"  output rows:", nr))
    ge.el <- vector()
    for(el2 in numbers[numbers!=el]){
      if(kanibal.matrix[el+1,el2+1]<kanibal.matrix[el2+1,el+1])
      ge.el <- c(ge.el,el2)
    }
    ge.pr <- rep(1,length(ge.el))
    s.tmp <-sum(ge.pr)
    ge.el <- c(ge.el,el)
    ge.el <- c(ge.el,n.ids) # add fake element
    fake.pr <- 1/(n.ids*n.ids)
    ge.pr <- c((ge.pr/n.ids),((n.ids-s.tmp)/n.ids-fake.pr))
    ge.pr <- c(ge.pr,fake.pr)
    s <- sum(ge.pr)
#    print(paste("suma rowna jest:", s))
    mc.tmp <- cbind(rep(el,length(ge.pr)), ge.el, ge.pr)    
    mc4 <- rbind(mc4,mc.tmp)
  }
  fake.out <- rep(1/n.ids,n.ids)
  mc.tmp <- cbind(rep(n.ids,n.ids), (0:(n.ids-1)), fake.out)    
  mc4 <- rbind(mc4,mc.tmp)
  nr <- nrow(mc4)
  cat(paste(n.ids+1,"\n",nr,"\n",sep=""),file=paste(output.dir,"/mc4.txt",sep=""))
  write.table(mc4,paste(output.dir,"/mc4.txt",sep=""), row.names=FALSE, col.names=FALSE,append=TRUE)
  system(paste("cp ",paste(output.dir,"/mc4.txt",sep=""), paste(MC.INPUT.DIR,"/mc.txt",sep="")))
  system(paste(MC.PROGRAM, " >",MC.OUTPUT.DIR,"mc_order.txt",sep=""))
  mc4.order<-as.vector(as.matrix(read.table(paste(MC.OUTPUT.DIR,"mc_order.txt",sep=""))))
  mc4.order <- mc4.order[1:(length(mc4.order)-1)]  #remove fake
  write.table(mc4.order,paste(output.dir,"/mc4_order.txt",sep=""), row.names=FALSE, col.names=FALSE)
  mc.scores <- cbind(mc.scores,mc4.order)
  order <- sort(mc.scores[,6], decreasing=TRUE,index.return=TRUE)$ix
  mc4.sorted <- mc.scores[order,]
  mc4.kanibal <- mc4.sorted[,1:2]
  mc4.kanibal <- kanibalize(mc4.kanibal)


#  mc4<-matrix(nrow=0,ncol=4)
#  print("processing mc4")
#  for(el in numbers){
#    nr <- nrow(mc4) 
##   print(paste("processing element:", el,"  output rows:", nr))
#    ge.el <- vector()
#    le.el <- vector()    
#    for(j in 1:length(ranks)){
#      v1 <- as.vector(ranks[[j]])
#      v2 <- as.vector(scores[[j]])
#      if (el %in% v1){
#        ind1 <- as.numeric(which(v1==el))
#        ind2 <- as.numeric(max(which(v2==(v2[ind1]))))
#        ge.el <- c(ge.el,v1[1:ind2])
#        if (ind2<length(v1)) le.el <- c(le.el,v1[ind2-1])
#      }
#    }
#    ge.el<-unique(ge.el)
#    ge.el <- ge.el[ge.el!=el]
#    le.el <- unique(le.el)
#    le.el <- le.el[!le.el%in%ge.el]
#    len.ge.el <- length(ge.el)
#    pr.vec <- rep(1,len.ge.el)
#    mc.tmp <- cbind(rep(el,len.ge.el),ge.el,pr.vec, rep(1,len.ge.el))
#    mc4 <- rbind(mc4,mc.tmp)
#    if(length(le.el)>0) flag = 2 else flag = 3
#    mc4 <- rbind(mc4,c(el,el,length(len.ge.el),flag))
#    for (l in le.el){
#      mc4 <- rbind(mc4,c(el,l,1/length(le.el),4))
#    }  
#  }
#  nr <- nrow(mc4)
#  e.pr <- 1/(nr)
#  e2.pr <- e.pr*e.pr
#  mc4[mc4[,4]== 1,3] <- e.pr
#  mc4[mc4[,4]== 2,3] <- (nr - mc4[mc4[,4]== 2,3])/nr - e2.pr
#  mc4[mc4[,4]== 3,3] <- (nr - mc4[mc4[,4]== 3,3])/nr
#  mc4[mc4[,3]== 4,3] <- mc4[mc4[,3]== 4] * e2.pr
#  mc4 <- mc4[,1:3]
#  cat(paste(n.ids,"\n",nr,"\n",sep=""),file=paste(output.dir,"/mc4.txt",sep=""))
#  write.table(mc4,paste(output.dir,"/mc4.txt",sep=""), row.names=FALSE, col.names=FALSE,append=TRUE)
#  system(paste("cp ",paste(output.dir,"/mc4.txt",sep=""), paste(MC.INPUT.DIR,"/mc.txt",sep="")))
#  system(paste(MC.PROGRAM, " >",MC.OUTPUT.DIR,"mc_order.txt",sep=""))
#  mc4.order<-as.vector(as.matrix(read.table(paste(MC.OUTPUT.DIR,"mc_order.txt",sep=""))))    
#  write.table(mc4.order,paste(output.dir,"/mc4_order.txt",sep=""), row.names=FALSE, col.names=FALSE,append=TRUE)
#  mc.scores <- cbind(mc.scores,mc4.order)
#  order <- sort(mc.scores[,6], decreasing=TRUE,index.return=TRUE)$ix
#  mc4.sorted <- mc.scores[order,]
#  mc4.kanibal <- mc4.sorted[,1:2]
#  mc4.kanibal <- kanibalize(mc4.kanibal)

  return(list(mc.scores=mc.scores, kanibal=kanibal.matrix, mc1.order=mc1.sorted[,1], mc1.kanibal=mc1.kanibal[,1],
              mc2.order=mc2.sorted[,1], mc2.kanibal=mc2.kanibal[,1], mc3.order=mc3.sorted[,1],mc3.kanibal=mc3.kanibal[,1],
              mc4.order=mc4.sorted[,1],mc4.kanibal=mc4.kanibal[,1])) 
}
