####
## peak.info.r
## peak statistics and graphics
## Janusz
####

rank.peaks<-function(aggregated.matrix,cluster.labels,patient.files,patient.class,patient.ids,output.dir,
                     n.best=NULL,soft.n.best=0, min.cluster.count=0, n.best.from.ppc=FALSE)
{
  indx<-find.large.clusters(aggregated.matrix, min.cluster.count)
  cut.aggregated.matrix<-aggregated.matrix[indx,]
  cut.cluster.labels<-as.matrix(cluster.labels[indx,])
  dimnames(cut.cluster.labels)<-list(dimnames(cluster.labels)[[1]][indx],dimnames(cluster.labels)[[2]])

  score.col <- dim(cluster.labels)[2]+1
  all <- dim(cut.aggregated.matrix)[1]
  if (is.null(n.best)) n.best<- all
## tt
  t.stat<-my.t.test(cut.aggregated.matrix,cut.cluster.labels,patient.class,patient.files,all)
  t.peak.info<-t.stat$best.info
  tt.res.all <- abs(t.peak.info[,c(1,score.col,score.col+1)])
  tt.res <- tt.res.all[1:n.best,]
  write.matrix(tt.res,file =paste(output.dir,"/tt.csv", sep=""),sep=",")
  if (soft.n.best>0){
     id1 <- max(which(abs(tt.res[,2])==abs(tt.res[soft.n.best,2])))
     id2 <- max(which(abs(tt.res[,2])>abs(tt.res[soft.n.best,2])))
     if ((id1-soft.n.best)>(soft.n.best-id2)) id <- id2 else id <- id1
     tt.res <- tt.res[1:id,]
  }
  gc()

 ## rf
  rf.stat <- random.forest(cut.aggregated.matrix,cut.cluster.labels,patient.class,patient.files,all)
  rf.peak.info <- rf.stat$best.info
  rf.res.all <- rf.peak.info[,c(1,score.col,score.col+1)]
  rf.res <- rf.res.all[1:n.best,]
  write.matrix(rf.res,file =paste(output.dir,"/rf.csv", sep=""),sep=",")
  if (soft.n.best>0){
    id1 <- max(which(rf.res[,2]==rf.res[soft.n.best,2]))
    id2 <- max(which(rf.res[,2]>rf.res[soft.n.best,2]))
    if ((id1-soft.n.best)>(soft.n.best-id2)) id <- id2 else id <- id1
    rf.res <- rf.res[1:id,]
  }
  gc()
   
## ppc  
  ppc.stat<-my.ppc(cut.aggregated.matrix,cut.cluster.labels,patient.class,patient.files,all)
  ppc.peak.info<-ppc.stat$best.info
# ppc.peak.info[is.na(ppc.peak.info)]<-0
#  if(n.best.from.ppc){ 
#    ppc.peak.info[,1]<-0:(n.best-1)  
#    ppc.first.data.col<-( dim(ppc.peak.info)[2] - length(patient.class) + 1 )
#    cut.aggregated.matrix=ppc.peak.info[,ppc.first.data.col:dim(ppc.peak.info)[2]]
#    cut.cluster.labels<-ppc.peak.info[,c(1,2)]
#    write.matrix(cut.cluster.labels,file =paste(output.dir,"/cluster_labels.ccc", sep=""),sep=",")
#  }
  ppc.res.all <- abs(ppc.peak.info[,c(1,score.col,score.col+1)])
  ppc.res <- ppc.res.all[1:n.best,]
  write.matrix(ppc.res,file =paste(output.dir,"/ppc.csv", sep=""),sep=",")
  if (soft.n.best>0){
     id1 <- max(which(abs(ppc.res[,2])==abs(ppc.res[soft.n.best,2])))
     id2 <- max(which(abs(ppc.res[,2])>abs(ppc.res[soft.n.best,2])))
     if ((id1-soft.n.best)>(soft.n.best-id2)) id <- id2 else id <- id1
     ppc.res <- ppc.res[1:id,]
  }
  gc()                                     
## ra  
#  ra.stat<-resistor.average(cut.aggregated.matrix,cut.cluster.labels,patient.class,patient.files,n.best)
#  ra.peak.info<-ra.stat$best.info
#  ra.res <- abs(ra.peak.info[,c(1,3)])
#  write.matrix(ra.res,file =paste(output.dir,"/ra.csv", sep=""),sep=",")
#  gc()
## bch
#  bch.stat<-bhattacharyya(cut.aggregated.matrix,cut.cluster.labels,patient.class,patient.files,n.best)
#  bch.peak.info<-bch.stat$best.info
#  bch.res <- abs(bch.peak.info[,c(1,3)])
#  write.matrix(bch.res,file =paste(output.dir,"/bch.csv", sep=""),sep=",")
#  gc()
## p.corr
#  p.corr.stat<-correlation(cut.aggregated.matrix,cut.cluster.labels,patient.class,patient.files,n.best,method="pearson")
#  p.corr.peak.info<-p.corr.stat$best.info
#  p.corr.res <-abs(p.corr.peak.info[,c(1,3)]) 
#  write.matrix(p.corr.res,file =paste(output.dir,"/pc.csv", sep=""),sep=",")
#  gc()
## s.corr
#  s.corr.stat<-correlation(cut.aggregated.matrix,cut.cluster.labels,patient.class,patient.files,n.best,method="spearman")
#  s.corr.peak.info<-s.corr.stat$best.info
#  s.corr.res <-abs(s.corr.peak.info[,c(1,3)]) 
#  write.matrix(s.corr.res,file =paste(output.dir,"/sc.csv", sep=""),sep=",")
#  gc()                      
## gk.stat  
#  gk.stat<-goodman.kruskal(cut.aggregated.matrix,cut.cluster.labels,patient.class,patient.files,n.best)   
#  gk.peak.info1<-gk.stat$best.info
#  gk.res <- abs(gk.peak.info1[,c(1,3)])
#  write.matrix(gk.res,file =paste(output.dir,"/gk.csv", sep=""),sep=",")
#  gc()
                       
## mi
  mi.stat<-mutual.info(cut.aggregated.matrix,cut.cluster.labels,patient.class,patient.files,all)
  mi.peak.info<-mi.stat$best.info
  mi.res.all <- abs(mi.peak.info[,c(1,score.col,score.col+1)])
  mi.res <- mi.res.all[1:n.best,]
  write.matrix(mi.res,file =paste(output.dir,"/mi.csv", sep=""),sep=",")
  if (soft.n.best>0){
     id1 <- max(which(mi.res[,2]==mi.res[soft.n.best,2]))
     id2 <- max(which(mi.res[,2]>mi.res[soft.n.best,2]))
     if ((id1-soft.n.best)>(soft.n.best-id2)) id <- id2 else id <- id1
     mi.res <- mi.res[1:id,]
  }
  gc()

  res.all <- list(tt=tt.res.all[,1], ppc=ppc.res.all[,1], mi=mi.res.all[,1], rf=rf.res.all[,1])
  max.id <-max(res.all$tt)
  n.res <- length(res.all)
  
  median.order<-vector()
  print("processing median")
  median.score <- rep(0,max.id +1) # na wszeliki wypadek jesli indeksy od zera
  for(i in 1:all){ 
    for(j in 1:n.res){
      el <- as.vector(res.all[[j]])[i]
      median.score[el+1] = median.score[el+1] + 1 
      if(median.score[el+1]>n.res/2) {
        median.order <- c(median.order,el)
        median.score[el+1] <- -n.res
      }
    }
  }
  
  res <- list(partial.orders=list(tt=tt.res, ppc=ppc.res, mi=mi.res, rf=rf.res), median.order = median.order)
                                       #, ra=ra.res, bch=bch.res, gk=gk.res, p.corr=p.corr.res, s.corr=s.corr.res)

#  len <- length(list)
#  v <- vector()
#  for(in 1:len){
#    v.tmp <- res[[i]][,1]
#    v <- c(v,v.tmp)    
#  }  

  return(res)

## tests comparison plot
#  d.test<-data.frame(ppc=ppc.stat$all.scores,mi=mi.stat$all.scores,ra=ra.stat$all.scores,gk=gk.stat$all.scores,
#                     t=t.stat$all.scores,p_cor=p.corr.stat$all.scores,s_cor= s.corr.stat$all.scores)                     
#    panel.cor <- function(x, y, digits=2, prefix="")
#      {
#          usr <- par("usr"); on.exit(par(usr))
#          par(usr = c(0, 1, 0, 1))
#          r <- abs(cor(x, y, method="spearman"))
#          txt <- round(r,2)
#          txt <- paste(prefix, txt, sep="")
#          text(0.5, 0.5, txt)
#      }
#    pch.plot<-function(x,y) plot(cbind(x,y),pch=".")
#
#    my.panel.smooth<-function(...) points(...,pch=".")
#  pdf(paste(output.dir,"/pairs.pdf",sep="")) 
#  pairs(as.matrix(abs(d.test)),lower.panel = my.panel.smooth,upper.panel=panel.cor)
#  dev.off()
} 

