####
## splits.r
## original code from PPC R package
## modified by Janusz 
####

# Przyklad wywolania:
#
#  mydata<-list(peaklist= data,ytr =as.factor(patient.class))
#  splits<-ibb.splits(mydata,n.splits,fix.at.one=fix.at.one)
#
#  gdzie data to macierz p x n, ktrej kolumnami sa p-wymiarowe obserwacje pacjentow, 
#  a patient.class to n-elementowy wektor klas pacjentow
#

my.ppc.splits<- function(mydata, nsplits,fix.at.one=FALSE){

  ytr <- mydata$ytr

  n.class<- table(ytr)

  which.is.max.na <- function(x)
        {
        xx <- x[!is.na(x)]
        y <- seq(length(xx))[xx == max(xx)]
        if(length(y) > 1) {
          y <- sample(y, 1)
        }
        o <- (1:length(x))[!is.na(x)]
        return(o[y])
      }
    ht <- mydata$peaklist
    alpha <- (1:nsplits)/(nsplits + 1)
    p <- nrow(ht)
    Y <- model.matrix( ~ factor(ytr) - 1, data = list(ytr = ytr)) #ytr = class
    K <- length(table(ytr))
    pr <- array(0, c(p, nsplits + 1, K))
    qu <- matrix(NA, nrow = p, ncol = nsplits + 1)

  #! at each site, compute proportion  of peak heights exceeding the split
  #! quantiles
  
    for(i in 1:p) {
     #if (ppc.options$debug) cat(i,fill=T)
      o <- ht[i,  ] > 0
      temp <- sort(ht[i, o])
      temp2 <- pmax(1, trunc(length(temp) * alpha))          
     
#    qu[i,  ] <- c(0, temp[temp2])
     qu[i,  ] <-as.vector(quantile(ht[i,  ],probs=seq(0,1,(1/(nsplits))),type=7))

      
      for(j in 1:(nsplits + 1)) {
        for(k in 1:K) {
          pr[i, j, k] <- sum(ht[i, Y[, k] == 1] > qu[i, j])/sum(Y[, k] == 1)
        }
      }
    }
     prmean <- apply(pr, c(1, 2), mean)

    #! find best split indices

    if(!fix.at.one) {
      prtemp <- apply(abs(pr - array(prmean, c(p, nsplits + 1, K))),
                      c(1, 2), sum)
      cuthat <- apply(prtemp, 1, which.is.max.na)
    }else { cuthat <- rep(1, p)}
    prhat <- matrix(NA, nrow = p, ncol = K)


    #!compute optimized proportions and  splits within 10% of the best

    prclose <- NULL


     prclose <- matrix(F, nrow = p, ncol = nsplits + 1)
     for(i in 1:p) {
       prhat[i,  ] <- pr[i, cuthat[i],  ]
       if(!fix.at.one){
         for(j in 1:(nsplits + 1)) {
           prclose[i, j] <- prtemp[i, j] > 0.9 * prtemp[i, cuthat[i]]
         }}
     }
# 
  my.splits<-(list(prhat = prhat, pr = pr, n.class=n.class, cutpoints = qu,
             cuthat = cuthat, prclose = prclose,nsplits=nsplits,
                    fix.at.one=fix.at.one))

   return(my.splits)
}

