####
## Utils
## ?
## Janusz
###

write.matrix <- function(data, file){
    write.table(data,file=file,row.names=F,col.names=F,quote=F)
}

weka.var.description<-function(relation.name,var.names,discr.val.count,class,class.labs)
{
  weka.desc<- paste("@relation",relation.name)
  for(i in 1:length(var.names)){
      vals<-"0"
    for(v in 1:(discr.val.count[i]-1)){
      vals<-paste(vals,v,sep=",")    
    } 
    weka.desc<-paste(weka.desc,"\n","@attribute",var.names[i],"{",vals, "}")
  }
  cl.vals<-paste(class.labs[1])
  for(cv in 2:length(class.labs)){
    cl.vals<-paste(cl.vals,class.labs[cv],sep=",")
  }       
  weka.desc<-paste(weka.desc,"\n","@attribute",class,"{",cl.vals,"}","\n","@data","\n")
}


# lin.scale<-function(X){
#   l.s<-function(x){
#     q<-quantile(x,c(.1,.9))
#     if(q[1]==q[2]) q<-quantile(x,c(.1,1))
#     if(q[1]==q[2]) ab<-c(0,0)
#     else ab<-solve(rbind(c(q[1],1),c(q[2],1)),c(0,1)) 
#     return(x*ab[1]+ab[2])        
#   }
#   Y<-t(apply(X,1,l.s))
#   Y[Y<0]<-0    
#   return(Y)
# }

lin.scale<-function(X){
  l.s<-function(x){
    q<-quantile(x,c(.1,.9))
    if(q[1]==q[2]) q<-quantile(x,c(.1,1))
    if(q[1]==q[2]){
     a<-1
     b<-0
    }   
    else {
      a<-1/(q[2]-q[1])
      b<-(1-a*q[2])
    }
    return(x*a+b)        
  }
  Y<-t(apply(X,1,l.s))
  Y[Y<0]<-0    
  return(Y)
}

  
