\name{MBC-methods}
\alias{MBC}
\title{
  Model based clustering of LC-MS data
\description{
 Align peaks together across samples using two-stage model based clustering.
}
\section{Methods}{
\describe{
\item{object = "xcmsSetWrapper"}{
  \code{
  MBC(object, eps = c(1,10), minPts = 0, maxsize = -1, minsize = 0, mznorm =1, rtnorm = 100, modelName = "C", eps.em = default.eps, mzstdev=0.04, rtstdev=80, sd.modes=c(1,1), minProb = 0, mulclust = 4, preclust)
    }
}
}}
\arguments{
  \item{object}{the \code{xcmsSetWrapper} object}
  \item{minfrac}{
    minimum fraction of samples necessary in at least one of the sample
    groups for it to be a valid group
  }
  \item{eps}{
    DBSCAN algorithm parameter defining neighborhood size
  }
  \item{minPts}{
   DBSCAN algorithm parameter defining the minimal number of points in the neighborhood
 }
 \item{maxsize}{
   maximum size of a preliminary cluster returned by DBSCAN
 }
 \item{minsize}{
   size filter on aligned peak clusters
  }
  \item{mznorm}{
  multiplicative normalization in the m/z dimension for initialization of clusters with hierarchical clustering
  }
  \item{rtnorm}{
  multiplicative normalization in the retention time dimension for initialization of clusters with hierarchical clustering
  }
  \item{modelName}{
    width of overlapping m/z slices to use for creating peak density
    chromatograms and grouping peaks across samples
  }
  \item{max}{
    maximum number of groups to identify in a single m/z slice
  }
  \item{sleep}{
    seconds to pause between plotting successive steps of the peak
    grouping algorithm. peaks are plotted as points showing relative
    intensity. identified groups are flanked by dotted vertical
    lines.
  }
}
\value{
  An \code{xcmsSet} object with peak group assignments and statistics.
}
\seealso{
  \code{\link{xcmsSet-class}},
  \code{\link{density}}
}
\keyword{methods}
\keyword{file}
